/*
* Skype Chat Logger, base class
*
* Coded by: Quequero
* Date: 14/Mar/2008
*
*/

#include "QSkype.h"
#include "QAgent.h"

QSkype::QSkype()
{
	hwChat = hwUserList = hwLogin = hwContacts = hwHistory = NULL;
}

BOOL QSkype::Is(HWND hw)
{
	UINT i = 0;
	WCHAR wClassName[256] = {0};
	WCHAR wTitle[256] = {0};

	PWCHAR pwClass[] = {
		L"TskMultiChatForm.UnicodeClass",
		0,
	};

	if(GetClassNameW(hw, wClassName, 256) == 0)
		return FALSE;

	while(pwClass[i]){
		if(!wcsncmp(pwClass[i], wClassName, wcslen(pwClass[i]))){
			GetWindowTextW(hw, wTitle, 256);
			
			if(wcsstr(wTitle, L"Skype Chat") != NULL)
				return TRUE;

			return FALSE;
		}

		i++;
	};

	return FALSE;
}

UINT QSkype::Version(const HWND hw)
{
	UINT uVersion;
	BYTE bVersion;

	uVersion = VersionEx(NULL);
	bVersion = (BYTE)((uVersion & 0xff000000) >> 24);

	switch(bVersion){
		case 0x03:
			return SKYPE_3;

		case 0x02:
			return SKYPE_2;

		case 0x01:
			return SKYPE_1;

		default:
			return UNKNOWN_VERSION;
	}

	return UNKNOWN_VERSION;
}

// Skype: HKEY_CURRENT_USER\Software\Skype\Phone\UI\Version
UINT QSkype::VersionEx(const HWND hw)
{
	HKEY hKey;
	DWORD dVersion, dSize = sizeof(DWORD);
	//BYTE bMajor, bMidHigh, bMidLow, bMinor;

	if(RegOpenKeyExW(HKEY_CURRENT_USER, L"Software\\Skype\\Phone\\UI", NULL, KEY_QUERY_VALUE, &hKey) != ERROR_SUCCESS)
		return UNKNOWN_VERSION;

	if(RegQueryValueExW(hKey, L"Version", NULL, NULL, (LPBYTE)&dVersion, &dSize) != ERROR_SUCCESS){
		RegCloseKey(hKey);
		return UNKNOWN_VERSION;
	}

	RegCloseKey(hKey);

	/*
	bMajor =   (BYTE)((dVersion & 0xff000000) >> 24);
	bMidHigh = (BYTE)((dVersion & 0x00ff0000) >> 16);
	bMidLow =  (BYTE)((dVersion & 0x0000ff00) >> 8);
	bMinor =   (BYTE)(dVersion & 0x000000ff);
	*/

	return (UINT)dVersion;
}

const PWCHAR QSkype::GetMessenger()
{ 
	return L"Skype"; 
}

